package com.qy.worksheetsystem.config;

/**
 * description: FeiShuConfig <br>
 * date: 2024/11/26 13:47 <br>
 * author: lhbj <br>
 * version: 1.0 <br>
 *
 */
public class FeiShuURLConfig {
    /**
     * 构造网页授权链接
     * client_id	是	企业的CorpID
     * redirect_uri	是	授权后重定向的回调链接地址，请使用urlencode对链接进行处理
     * scope	是	应用授权作用域。企业自建应用固定填写：snsapi_base
     * state	否	重定向后会带上state参数，企业可以填写a-zA-Z0-9的参数值，长度不可超过128个字节
     */
    public static final String authorize_URL="https://accounts.feishu.cn/open-apis/authen/v1/authorize?scope=contact:group:readonly%20offline_access";
    /**
     * 获取用户的调用接口凭证
     * 请求头  必填   描述
     * Content-Type 是 固定值：application/json; charset=utf-8
     * 请求体  必填   描述
     * grant_type 是 授权类型。固定值：authorization_code
     * client_id 是 应用的 App ID，可以在开发者后台中的应用详情页面找到该值。
     * client_secret 是 应用的 App Secret，可以在开发者后台中的应用详情页面找到该值
     * code 是 授权码，详见获取授权码。
     * redirect_uri 是 授权后重定向的回调链接地址，请使用urlencode对链接进行处理
     */
    public static final String getUser_access_token_URL="https://open.feishu.cn/open-apis/authen/v2/oauth/token";

    /**
     * 请求头  必填   描述 示例值："Bearer u-cjz1eKCEx289x1TXEiQJqAh5171B4gDHPq00l0GE1234"
     * Authorization 是 user_access_token
     */
    public static final String getUser_info_URL = "https://open.feishu.cn/open-apis/authen/v1/user_info";

}
