package com.qy.worksheetsystem.service.impl;

import com.qy.worksheetsystem.model.mapper.PersonMapper;
import com.qy.worksheetsystem.service.PersonService;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.Map;

/**
 * @BelongsProject: workSheetSystem
 * @BelongsPackage: com.qy.worksheetsystem.service.impl
 * @Author: lhbj
 * @CreateTime: 2024-12-02  18:24
 * @Description: TODO
 * @Version: 1.0
 */
@Slf4j
@Service
public class PersonServiceImpl implements PersonService {

    @Resource
    private PersonMapper personMapper;

    @Override
    public Map<String, String> getPersonByUserId(String userid) {
        return personMapper.getPersonByUserId(userid);
    }

    @Override
    public Map<String, String> getPersonByOpenId(String openid) {
        return personMapper.getPersonByOpenId(openid);
    }

    @Override
    public Map<String, String> getPersonByJobNo(String jobNo) {
        return personMapper.getPersonByJobNo(jobNo);
    }
    @Override
    public Map<String, String> getPersonByPersonId(String id) {
        return personMapper.getPersonByPersonId(id);
    }
    @Override
    public Map<String, String> getPersonAndProjectByUserId(String userid, String projectId) {
        return personMapper.getPersonAndProjectByUserId(userid,projectId);
    }

    @Override
    public Map<String, String> getPersonAndProjectByOpenId(String openid, String projectId) {
        return personMapper.getPersonAndProjectByOpenId(openid,projectId);
    }

    @Override
    public Map<String, String> getPersonAndProjectByJobNo(String jobNo, String projectId) {
        return personMapper.getPersonAndProjectByJobNo(jobNo,projectId);
    }
    @Override
    public Map<String, String> getPersonAndProjectByPersonId(String id, String projectId) {
        return personMapper.getPersonAndProjectByPersonId(id,projectId);
    }
    @Override
    public Map<String, String> getProjectManagementInfoBYId(String id, String personId) {
        return personMapper.getProjectManagementInfoBYId(id,personId);
    }
}
