package com.qy.worksheetsystem.util;

import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Date;

public class DateUtil {
    public static int isValidDate(String startTime, String endTime) {
        int convertSuccess = 0;
        // 指定日期格式为四位年/两位月份/两位日期，注意yyyy/MM/dd区分大小写；
        SimpleDateFormat format = new SimpleDateFormat("yyyy-MM-dd");
        Date sTime=null;
        Date eTime=null;
        try {
            // 设置lenient为false. 否则SimpleDateFormat会比较宽松地验证日期，比如2007/02/29会被接受，并转换成2007/03/01
            format.setLenient(false);
            sTime= format.parse(startTime);
            eTime= format.parse(endTime);
            if (sTime.getTime() > eTime.getTime()) {
                convertSuccess=2;
            }
        } catch (ParseException e) {
            // e.printStackTrace();
            // 如果throw java.text.ParseException或者NullPointerException，就说明格式不对
            convertSuccess = 1;
        }
        return convertSuccess;
    }
}
