/**
 * 工时确认单-列表
 */
shr.defineClass("shr.project.workHoursConfirmList", shr.framework.List, {
	initalizeDOM: function () {
		shr.project.workHoursConfirmList.superClass.initalizeDOM.call(this);
		var _self = this;
	},
	/**
	*描述：单据撤回操作
	*逻辑："未审批"、"审批中"的单据才能撤回！
	*/
	abortBillAction : function (event) {
		var _self = this;
		var selectedIds = _self.getSelectedIds();
		if( !selectedIds ){
			return ;
		}
		_self.doRemoteAction({
			method: 'abortBill',
			billId: selectedIds,
			success : function(response) {					
				_self.reloadGrid();
			}
		});
	},
	
	/**
	*描述：单据反审批操作
	*逻辑："审批通过"的单据才能反审批！
	*/
	untiCheckAction : function (event) {
		var _self = this;
		var selectedIds = _self.getSelectedIds();
		if( !selectedIds ){
			return ;
		}
		_self.doRemoteAction({
			method: 'untiCheck',
			billId: selectedIds,
			success : function(response) {					
				_self.reloadGrid();
			}
		});
	},
	/**
	 * 项目打卡确认单
	 * 
	 * @action
	 */
	worhHoursServiceAction: function () {
		var that = this;

		shr.callService({
			serviceName: "WorhHoursService",
			param: {},
			success: function (data) {// 回调成功
				if (data == "") {
					shr.showWarning({ message: " 执行成功!!" });
					setTimeout(function () {
						that.reloadPage();
					}, 2000); // 2秒
				}
			}
		});

	},
	/**
	 * 项目打卡确认单-事务
	 */
	initJobAction() {
		var _self = this;
		var html = [], buttons = [], $dialog = $("#generateDataDialog"), $body = $(document.body);
		if ($dialog.size() == 0) {
			$dialog = $("<div id='generateDataDialog' class='tiny-dialog'></div>").appendTo($body);
		}
		html = ['<div id="generateDataHtml" style="margin-left:20px">',
			'<div class="sync-row row-fluid">',
			'<div data-ctrlrole="labelContainer">',
			'<div class="col-lg-6 textLeft"><div class="field_label" title="' + '前延天数设置' + '">' +
			' ' + '</div></div>',
			'<div class="col-lg-6 field-ctrl"> 前延天数:&nbsp<input type = "number" min = "0" mxa="500" id="day" name="day" class="block-father input-height" value="3" validate="{required:true}"placeholder="" type="text" dataextenal="" autocomplete="off" istotemplate="true" ctrlrole="datetimepicker"></input></div>',
			'</div>',
			'</div>',
			//'<div class="sync-row row-fluid" style="margin-top:20px">',
			//'<div data-ctrlrole="labelContainer">',
			//'<div class="col-lg-6 textLeft"><div class="field_label"  title="' + '时间段' + '">' +
			//'时间段' + '</div></div>',
			//'<div class="col-lg-6 field-ctrl">',
			//'<div>',
			//'<div style="display: inline-block; width: 135px;" >' +
			//'<input id="startDate" name="startDate" class="block-father input-height" value="" validate="" placeholder="" type="text" dataextenal="" autocomplete="off" istotemplate="true" ctrlrole="datetimepicker">' +
			//'</div>',
			//'<div style="display: inline-block;   position: absolute;margin-left:5px" >至</div>   ',
			//'<div style="display: inline-block;   position: absolute;width: 135px; margin-left:25px" >',
			//'<input id="endDate" name="endDate" class="block-father input-height" value="" validate="" placeholder="" type="text" dataextenal="" autocomplete="off" istotemplate="true" ctrlrole="datetimepicker"></div></div></div>',
			//'</div>',
			'</div>',
			'</div>',
			'</div>'];

		var saveSettingButton = _self.getSaveButton();
		buttons.push(saveSettingButton);
		showDialog("#generateDataDialog",
			'执行计划规则',
			html.join(""), buttons, 350, 250, '取消');
		var startDate_json = {};
	//	startDate_json.format = 'yyyy-mm-dd';
		//startDate_json.id = "startDate";
		//startDate_json.isRemoveDay = false;
	//	startDate_json.ctrlType = 'date';
	//	$('#startDate').shrDateTimePicker(startDate_json);
		//var endDate_json = {};
		//endDate_json.format = 'yyyy-mm-dd';
		//endDate_json.id = "startDate";
		//endDate_json.isRemoveDay = false;
		//endDate_json.ctrlType = 'date';
		//$('#endDate').shrDateTimePicker(endDate_json);
	},
	getSaveButton: function () {
		var _self = this;
		var saveSettingButton = {
			text: '确定',
			click: function () {
				var day = $('#day').val()
				// var startDate = $('#startDate').shrDateTimePicker("getValue");
				// var endDate = $('#endDate').shrDateTimePicker("getValue");
				 if (day.length == 0) {
					 shr.showError({ message: '请填写前延天数！', hideAfter: 5 });
					 return;
				 }
				 if (day == 0) {
					 shr.showError({ message: '前延天数不能为0！', hideAfter: 5 });
					 return;
				 }
				 
				// if (startDate.length > 0 && endDate.length > 0) {
					// let date1 = new Date(startDate);
					// let date2 = new Date(endDate);
					// if (date1.getTime() > date2.getTime()) {
						// shr.showError({ message: '开始时间不能大于结束时间', hideAfter: 5 });
					// }
				// }

				var param = {};
				param.day = day;
				//param.startDate = startDate;
				//param.endDate = endDate;
				//调用job 方法
				console.log("param", param);
				_self.remoteCall({
					method: 'initJob',
					param: param,
					async: false,
					success: function (data) {
						$("#generateDataDialog").remove()
						shr.showWarning({ message: " 后台任务已经开始执行，请您耐心等待！稍后您可在“后台事务”中查看执行结果！" });
						setTimeout(function () {
							that.reloadPage();
						}, 2000); // 2秒
						
					}, error: function (response) {
						shr.showError({
							message: response.summary
							, hideAfter: 2
						});
					}
				});
			}
		}
		return saveSettingButton;
	},

});