package com.kingdee.eas.hr.perf.task;

import com.aliyun.odps.utils.StringUtils;
import com.kingdee.bos.dao.ormapping.ObjectUuidPK;
import com.kingdee.bos.util.BOSUuid;
import com.kingdee.eas.basedata.org.AdminOrgUnitInfo;
import com.kingdee.eas.basedata.org.HROrgUnitInfo;
import com.kingdee.eas.basedata.person.PersonInfo;
import com.kingdee.eas.hr.ats.AtsUtil;
import com.kingdee.eas.hr.ats.lightapp.util.NumberCodeRule;
import com.kingdee.eas.hr.perf.*;
import com.kingdee.eas.hr.perf.app.TimeTypeEunm;
import com.kingdee.eas.hr.project.*;
import com.kingdee.eas.util.app.DbUtil;
import com.kingdee.jdbc.rowset.IRowSet;
import com.kingdee.shr.base.syssetting.app.osf.OSFAppUtil;
import com.kingdee.shr.base.syssetting.context.SHRContext;
import com.kingdee.shr.base.syssetting.exception.ShrWebBizException;
import com.kingdee.shr.perfweb.app.base.evalplan.IPerfPeriod;
import com.kingdee.shr.perfweb.app.base.evalplan.PerfPeriodFactory;
import com.kingdee.shr.perfweb.app.base.evalplan.PerfPeriodInfo;
import com.kingdee.util.UuidException;
import org.apache.commons.collections4.MultiMap;
import org.apache.commons.collections4.map.MultiValueMap;
import org.apache.log4j.Logger;

import javax.ejb.*;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.math.BigDecimal;
import java.rmi.RemoteException;

import com.kingdee.bos.*;
import com.kingdee.bos.util.BOSObjectType;
import com.kingdee.bos.metadata.IMetaDataPK;
import com.kingdee.bos.metadata.rule.RuleExecutor;
import com.kingdee.bos.metadata.MetaDataPK;
//import com.kingdee.bos.metadata.entity.EntityViewInfo;
import com.kingdee.bos.framework.ejb.AbstractEntityControllerBean;
import com.kingdee.bos.framework.ejb.AbstractBizControllerBean;
//import com.kingdee.bos.dao.IObjectPK;
import com.kingdee.bos.dao.IObjectValue;
import com.kingdee.bos.dao.IObjectCollection;
import com.kingdee.bos.service.ServiceContext;
import com.kingdee.bos.service.IServiceContext;

import com.kingdee.eas.common.EASBizException;

import java.lang.String;
import java.sql.SQLException;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.*;

public class PerformanceResultFacadeControllerBean extends AbstractPerformanceResultFacadeControllerBean {
    private static Logger logger =
            Logger.getLogger("com.kingdee.eas.hr.perf.task.PerformanceResultFacadeControllerBean");
    private Properties propt = new Properties();

    public PerformanceResultFacadeControllerBean() {
        try {
            this.propt.load(new FileInputStream(System.getProperty("EAS_HOME") + "/server/properties/hty/configuration.properties"));
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    /**
     * ĿЧ
     *
     * @param ctx
     * @param start
     * @param end
     * @param typeName
     * @throws BOSException
     * @throws EASBizException
     */
    @Override
    protected Map _generatePerformance(Context ctx, String start, String end, String typeName) throws BOSException, EASBizException {
        Map callService = null;
        try {
            SimpleDateFormat formatter = new SimpleDateFormat("yyyy-MM-dd");
            Date startDate = formatter.parse(start);
            Date endDate = formatter.parse(end);
            TimeTypeEunm anEnum = TimeTypeEunm.getEnum(typeName);
            //ѯid
            Set<String> set = new HashSet<>();
            String sql = "select fid id ,FPSTARTDATE sdate,FPENDDATE edate from T_EVA_PerfPeriod where  to_char(FPSTARTDATE, 'yyyy-mm-dd') >= '" + start + "' and to_char(FPENDDATE, 'yyyy-mm-dd') <= '" + end + "'";
            IRowSet rs = DbUtil.executeQuery(ctx, sql.toString());
            while (rs.next()) {
                String id = rs.getString("id");
                String sdate = rs.getString("sdate");
                String edate = rs.getString("edate");
                set.add(id);
            }
            Map<String, String> map = new HashMap<>();
            map.put("periodids", AtsUtil.convertSetToString(set));
            map.put("sdate", start);//ڿʼʱ
            map.put("edate", end);//ڽʱ
            callService = (Map) OSFAppUtil.callService(ctx, "ProjectEvalruleService", map);
            IPerfPeriod localInstance = PerfPeriodFactory.getLocalInstance(ctx);
            for (Object personId : callService.keySet()) {
                PerformanProjectPersonInfo info = new PerformanProjectPersonInfo();
                PersonInfo personInfo = new PersonInfo();
                AdminOrgUnitInfo adminOrgUnitInfo = new AdminOrgUnitInfo();
                PerfPeriodInfo perfPeriodInfo = new PerfPeriodInfo();

                personInfo.setId(BOSUuid.read((String) personId));
                info.setPerson(personInfo);
                HROrgUnitInfo hrOrgUnitInfo = new HROrgUnitInfo();
                hrOrgUnitInfo.setId(BOSUuid.read("00000000-0000-0000-0000-000000000000CCE7AED4"));
                info.setHrOrgUnit(hrOrgUnitInfo);
                info.setTimeType(anEnum);
                info.setStartDate(startDate);
                info.setEndDate(endDate);
                List<Object> list = (List) callService.get(personId);
                String billNumber = NumberCodeRule.readCodeRuleNumber(info, NumberCodeRule.getMainOrgByCu(ctx), ctx);
                info.setNumber(billNumber);
                BigDecimal zero = BigDecimal.ZERO;
                for (int i = 0; i < list.size(); i++) {
                    PerformanProjectPersonEntryInfo entry = new PerformanProjectPersonEntryInfo();
                    ProjectManagementInfo projectManagementInfo = new ProjectManagementInfo();
                    ProjectRoleInfo projectRoleInfo = new ProjectRoleInfo();
                    ProjectTypeInfo projectTypeInfo = new ProjectTypeInfo();
                    Map listMap = (Map) list.get(i);
                    String projectId = (String) listMap.get("projectid");
                    String periodId = (String) listMap.get("periodId");
                    String roleId = (String) listMap.get("roleId");
                    String projectTypeId = (String) listMap.get("projectTypeId");//ɫid
                    String adminid = (String) listMap.get("adminid");
                    BigDecimal projectPerformance = listMap.get("projectPerformance") == null ? BigDecimal.ZERO : (BigDecimal) listMap.get("projectPerformance");//ĿЧ

                    BigDecimal singleProject = listMap.get("singleProject") == null ? BigDecimal.ZERO : (BigDecimal) listMap.get("singleProject");//˴Ч
                    BigDecimal itemWeight = listMap.get("itemWeight") == null ? BigDecimal.ZERO : (BigDecimal) listMap.get("itemWeight");//ĿȨ
                    zero = zero.add(projectPerformance.multiply(singleProject).multiply(itemWeight));//ϵ

                    adminOrgUnitInfo.setId(BOSUuid.read(adminid));
                    perfPeriodInfo.setId(BOSUuid.read(periodId));
                    projectTypeInfo.setId(BOSUuid.read(projectTypeId));
                    projectManagementInfo.setId(BOSUuid.read(projectId));
                    projectRoleInfo.setId(BOSUuid.read(roleId));
                    info.setOrgDep(adminOrgUnitInfo);
                    info.setPerfPlan(perfPeriodInfo);
                    info.setPerPojectSum(zero);//ĿЧ
                    entry.setParticipate(projectManagementInfo);//Ŀid
                    entry.setProjectRole(projectRoleInfo);//ɫid
                    //
                    entry.setProjectPerformance(projectPerformance);//
                    entry.setSingleProject(singleProject);//
                    entry.setItemWeight(itemWeight);//
                    info.getEntrys().add(entry);
                    //
                    StringBuffer perfPeriodName = new StringBuffer();
                    //ڱ
                    StringBuffer perfPeriodNumber = new StringBuffer();
                    PerformanProjectPersonPerfPlanMultipleInfo multipleInfo = new PerformanProjectPersonPerfPlanMultipleInfo();
                    PerfPeriodInfo periodInfo = localInstance.getPerfPeriodInfo(new ObjectUuidPK(periodId));
                    multipleInfo.setPerfPlanMultiple(periodInfo);
                    info.getPerfPlanMultiple().add(multipleInfo);
                    perfPeriodName.append(periodInfo.getName()).append("");
                    perfPeriodNumber.append(periodInfo.getNumber()).append("");
                    perfPeriodName.deleteCharAt(perfPeriodName.length() - 1);
                    //д뿼
                    info.setPerfPlanStr(perfPeriodName.toString());
                    //д뿼ڱ
                    perfPeriodNumber.deleteCharAt(perfPeriodNumber.length() - 1);
                    info.setPerfPlanNumber(perfPeriodNumber.toString());
                    info.setDescription(periodId);

                }
                PerformanProjectPersonFactory.getLocalInstance(ctx).save(info);
            }
        } catch (ParseException e) {
            e.printStackTrace();
            throw new BOSException(e);
        } catch (SQLException e) {
            e.printStackTrace();
            throw new BOSException(e);
        }
        return callService;
    }

    /**
     * ɼЧһ
     *
     * @param ctx
     * @param start
     * @param end
     * @param typeName
     * @throws BOSException
     * @throws EASBizException
     */
    @Override
    protected Map _generateProjectOne(Context ctx, String start, String end, String typeName) throws BOSException {
        try {
            SimpleDateFormat formatter = new SimpleDateFormat("yyyy-MM-dd");
            Date startDate = formatter.parse(start);
            Date endDate = formatter.parse(end);
            TimeTypeEunm anEnum = TimeTypeEunm.getEnum(typeName);
            MultiMap multiMap = new MultiValueMap<>();
            Set<String> set = new HashSet<String>();


            StringBuffer sql = new StringBuffer(); //id
            sql.append("SELECT").append("\n");
            sql.append("two.CFPERSONID twoPersonId,").append("\n");
            sql.append("two.CFORGDEPID twoOrgDep,").append("\n");
            sql.append("two.CFPERPOJECTSUM twoProjectSum,").append("\n");
            sql.append("CASE").append("\n");
            sql.append("    WHEN type.fname_l2 = 'һ' THEN two.CFORGDEPID").append("\n");
            sql.append("    WHEN type.fname_l2 = '' THEN admin.FPARENTID").append("\n");
            sql.append("ELSE two.CFORGDEPID END AS adminID").append("\n");
            sql.append("FROM CT_HR_PerformanProjectTwo two").append("\n");
            sql.append("left join T_org_admin admin on admin.fid = two.CFORGDEPID").append("\n");
            sql.append("left join T_Org_LayerType type on type.fid = admin.FLAYERTYPEID").append("\n");

            sql.append("where to_char(two.CFSTARTDATE, 'yyyy-mm-dd') >= '" + start + "' and to_char(two.CFENDDATE, 'yyyy-mm-dd') <= '" + end + "'").append("\n");
            sql.append("and two.FBILLSTATE = '3'").append("\n");
            IRowSet rs = DbUtil.executeQuery(ctx, sql.toString());
            while (rs.next()) {
                Map<String, Object> map = new HashMap<>();
                String twoPersonId = rs.getString("twoPersonId");
                String twoOrgDep = rs.getString("twoOrgDep");
                BigDecimal twoProjectSum = rs.getBigDecimal("twoProjectSum");
                String adminID = rs.getString("adminID");
                map.put("twoPersonId", twoPersonId);
                map.put("twoOrgDep", twoOrgDep);
                map.put("twoProjectSum", twoProjectSum);
                multiMap.put(adminID, map);
                set.add(adminID);
            }

            Map<String, String> mapIds = new HashMap<>();
            StringBuffer stringBuffer = new StringBuffer();
            stringBuffer.append("SELECT").append("\n");
            stringBuffer.append("admin.fid adminId,").append("\n");
            stringBuffer.append("pp.FPERSONID depPersonId").append("\n");
            stringBuffer.append("FROM T_org_admin admin").append("\n");
            stringBuffer.append("left join T_HR_PersonPosition pp on admin.FRESPONPOSITIONID = pp.FPRIMARYPOSITIONID").append("\n");
            stringBuffer.append("where admin.fid in(").append("\n");
            stringBuffer.append(AtsUtil.convertSetToString(set)).append("\n");
            stringBuffer.append(")").append("\n");
            IRowSet iRowSet = DbUtil.executeQuery(ctx, stringBuffer.toString());
            while (iRowSet.next()) {
                String depPersonId = iRowSet.getString("depPersonId");//֯
                String adminID = iRowSet.getString("adminId");
                mapIds.put(adminID, depPersonId);
            }


            for (String adminID : set) {
                List list = (List) multiMap.get(adminID);
                PerformanProjectOneInfo info = new PerformanProjectOneInfo();
                PersonInfo personInfo = new PersonInfo();
                AdminOrgUnitInfo adminOrgUnitInfo = new AdminOrgUnitInfo();
                HROrgUnitInfo hrOrgUnitInfo = new HROrgUnitInfo();
                hrOrgUnitInfo.setId(BOSUuid.read("00000000-0000-0000-0000-000000000000CCE7AED4"));
                info.setHrOrgUnit(hrOrgUnitInfo);
                String billNumber = NumberCodeRule.readCodeRuleNumber(info, NumberCodeRule.getMainOrgByCu(ctx), ctx);
                info.setNumber(billNumber);
                info.setTimeType(anEnum);
                info.setStartDate(startDate);
                info.setEndDate(endDate);
                BigDecimal zero = BigDecimal.ZERO;
                int index = 0;
                for (int i = 0; i < list.size(); i++) {
                    PerformanProjectOneEntryInfo entryInfo = new PerformanProjectOneEntryInfo();
                    AdminOrgUnitInfo adminOrgUnitTwoInfo = new AdminOrgUnitInfo();
                    PersonInfo personTwoInfo = new PersonInfo();
                    Map map = (Map) list.get(i);
                    //String orgParentId = (String) map.get("orgParentId");
                    String personId = mapIds.get(adminID) == null ? "" : mapIds.get(adminID);
                    String twoPersonId = (String) map.get("twoPersonId");
                    String twoOrgDep = (String) map.get("twoOrgDep");
                    BigDecimal twoProjectSum = (BigDecimal) map.get("twoProjectSum");
                    adminOrgUnitInfo.setId(BOSUuid.read(adminID));
                    info.setOrgDep(adminOrgUnitInfo);
                    if (StringUtils.isNotBlank(personId)) {
                        personInfo.setId(BOSUuid.read(personId));
                    }

                    info.setPerson(personInfo);
                    adminOrgUnitTwoInfo.setId(BOSUuid.read(twoOrgDep));
                    entryInfo.setSecondDep(adminOrgUnitTwoInfo);
                    personTwoInfo.setId(BOSUuid.read(twoPersonId));
                    entryInfo.setSecondDepPerson(personTwoInfo);
                    zero = zero.add(twoProjectSum);
                    if (index == list.size() - 1) {
                        zero = zero.divide(BigDecimal.valueOf(list.size()));
                        info.setPerPojectSum(zero);
                    }
                    index++;
                    entryInfo.setProjectModulus(twoProjectSum);

                    info.getEntrys().add(entryInfo);
                }
                PerformanProjectOneFactory.getLocalInstance(ctx).save(info);
            }
        } catch (Exception e) {
            e.printStackTrace();
            throw new BOSException(e);
        }
        return null;
    }

    /**
     * ɼЧ
     *
     * @param ctx
     * @param start
     * @param end
     * @param typeName
     * @throws BOSException
     * @throws EASBizException
     */
    @Override
    protected Map _generateProjectTwo(Context ctx, String start, String end, String typeName) throws BOSException, EASBizException {
        Map callService = null;
        try {
            SimpleDateFormat formatter = new SimpleDateFormat("yyyy-MM-dd");
            Date startDate = formatter.parse(start);
            Date endDate = formatter.parse(end);
            TimeTypeEunm anEnum = TimeTypeEunm.getEnum(typeName);
            //ѯid
            Set<String> set = new HashSet<>();
            String sql = "select fid id from T_EVA_PerfPeriod where  to_char(FPSTARTDATE, 'yyyy-mm-dd') >= '" + start + "' and to_char(FPENDDATE, 'yyyy-mm-dd') <= '" + end + "'";
            IRowSet rs = DbUtil.executeQuery(ctx, sql.toString());
            while (rs.next()) {
                String id = rs.getString("id");
                set.add(id);
            }
            Map<String, String> map = new HashMap<>();
            map.put("periodids", AtsUtil.convertSetToString(set));
            String P2 = propt.getProperty("Project2");
            ProjectTypeCollection projectTypeCollection = ProjectTypeFactory.getLocalInstance(ctx).getProjectTypeCollection("where number = '" + P2 + "'");
            callService = (Map) OSFAppUtil.callService(ctx, "ProjectEvalruleService", map);
            if (projectTypeCollection.size() == 0) {
                callService.put("shrWebBiz", "δҵָ" + P2 + "飡");
            }
            map.put("istype2", P2);
            //Map callService = (Map) OSFAppUtil.callService(ctx, "ProjectEvalruleService", map);
            Set<Object> setIds = new HashSet<>();
            for (Object personId : callService.keySet()) {
                setIds.add(personId);
            }

            Set<String> setDepIds = new HashSet<>();
            StringBuffer str = new StringBuffer();
            str.append("SELECT").append("\n");
            str.append("pp.FPERSONID personId,").append("\n");
            str.append("admin.FLAYERTYPEID,").append("\n");
            str.append("type.fname_l2,").append("\n");
            str.append("CASE").append("\n");
            str.append("    WHEN type.fname_l2 = '' THEN pp.FPERSONDEP").append("\n");
            str.append("    WHEN type.fname_l2 = 'С' THEN admin.FPARENTID").append("\n");
            str.append("ELSE pp.FPERSONDEP END AS adminID").append("\n");
            str.append("FROM T_HR_PersonPosition pp").append("\n");
            str.append("left join T_org_admin admin on pp.FPERSONDEP = admin.fid").append("\n");
            str.append("left join T_Org_LayerType type on type.fid = admin.FLAYERTYPEID").append("\n");
            str.append("where pp.FPERSONID in(").append("\n");
            str.append(AtsUtil.convertSetToString(setIds)).append("\n");
            str.append(")").append("\n");
            System.out.println("setDepIds" + setDepIds);
            IRowSet rowSet = DbUtil.executeQuery(ctx, str.toString());
            MultiMap listHashMap = new MultiValueMap<>();
            while (rowSet.next()) {
                String personId = rowSet.getString("personId");
                //String depPersonId = rowSet.getString("depPersonId");//֯
                String adminID = rowSet.getString("adminID");
                setDepIds.add(adminID);
                List<Object> list = (List) callService.get(personId);
                listHashMap.put(adminID, list);
            }


            Map<String, String> mapIds = new HashMap<>();
            StringBuffer stringBuffer = new StringBuffer();
            stringBuffer.append("SELECT").append("\n");
            stringBuffer.append("admin.fid adminId,").append("\n");
            stringBuffer.append("pp.FPERSONID depPersonId").append("\n");
            stringBuffer.append("FROM T_org_admin admin").append("\n");
            stringBuffer.append("left join T_HR_PersonPosition pp on admin.FRESPONPOSITIONID = pp.FPRIMARYPOSITIONID").append("\n");
            stringBuffer.append("where admin.fid in(").append("\n");
            stringBuffer.append(AtsUtil.convertSetToString(setDepIds)).append("\n");
            stringBuffer.append(")").append("\n");
            System.out.println("stringBuffer" + stringBuffer);
            IRowSet iRowSet = DbUtil.executeQuery(ctx, stringBuffer.toString());
            while (iRowSet.next()) {
                String depPersonId = iRowSet.getString("depPersonId");//֯
                String adminID = iRowSet.getString("adminId");
                setDepIds.add(adminID);
                mapIds.put(adminID, depPersonId);
            }

            for (String adminID : setDepIds) {
                System.out.println(adminID);
                PerformanProjectTwoInfo info = new PerformanProjectTwoInfo();
                PersonInfo personInfo = new PersonInfo();
                AdminOrgUnitInfo adminOrgUnitInfo = new AdminOrgUnitInfo();
                PerfPeriodInfo perfPeriodInfo = new PerfPeriodInfo();
                List list = (List) listHashMap.get(adminID);
                //ҵ֯
                HROrgUnitInfo hrOrgUnitInfo = new HROrgUnitInfo();
                hrOrgUnitInfo.setId(BOSUuid.read("00000000-0000-0000-0000-000000000000CCE7AED4"));
                info.setHrOrgUnit(hrOrgUnitInfo);
                String billNumber = NumberCodeRule.readCodeRuleNumber(info, NumberCodeRule.getMainOrgByCu(ctx), ctx);
                info.setNumber(billNumber);
                info.setTimeType(anEnum);
                info.setStartDate(startDate);
                info.setEndDate(endDate);
                BigDecimal zero = BigDecimal.ZERO;
                int index = 0;
                for (int i = 0; i < list.size(); i++) {
                    List mapList = (List) list.get(i);
                    System.out.println("System.out.println(mapListww)" + mapList);
                    for (int j = 0; j < mapList.size(); j++) {
                        PerformanProjectTwoEntryInfo entry = new PerformanProjectTwoEntryInfo();
                        ProjectManagementInfo projectManagementInfo = new ProjectManagementInfo();
                        ProjectRoleInfo projectRoleInfo = new ProjectRoleInfo();
                        ProjectTypeInfo projectTypeInfo = new ProjectTypeInfo();
                        PersonInfo perInfo = new PersonInfo();
                        Map listMap = (Map) mapList.get(j);
                        String projectId = (String) listMap.get("projectid");
                        String periodId = (String) listMap.get("periodId");
                        String roleId = (String) listMap.get("roleId");
                        String projectTypeId = (String) listMap.get("projectTypeId");//ɫid
                        String adminid = (String) listMap.get("adminid");
                        String personId = (String) listMap.get("personId");
                        BigDecimal projectPerformance = (BigDecimal) listMap.get("projectPerformance");//ĿЧ
                        //BigDecimal singleProject = (BigDecimal)listMap.get("singleProject");//˴Ч
                        BigDecimal itemWeight = (BigDecimal) listMap.get("itemWeight");//ĿȨ
                        BigDecimal projectkPicoeff = (BigDecimal) listMap.get("projectkPicoeff");//ĿЧ
                        if (StringUtils.isNotBlank(adminID)) {
                            adminOrgUnitInfo.setId(BOSUuid.read(adminID));

                        }
                        perfPeriodInfo.setId(BOSUuid.read(periodId));
                        projectManagementInfo.setId(BOSUuid.read(projectId));
                        projectRoleInfo.setId(BOSUuid.read(roleId));
                        projectTypeInfo.setId(BOSUuid.read(projectTypeId));
                        perInfo.setId(BOSUuid.read(personId));
                        if (StringUtils.isNotBlank(adminID)) {
                            String depPersonId = mapIds.get(adminID);
                            if (StringUtils.isNotBlank(depPersonId)) {
                                personInfo.setId(BOSUuid.read(depPersonId));

                            }
                        }
                        //                    String depPersonId = mapIds.get(adminID);
                        //                    personInfo.setId(BOSUuid.read(depPersonId));
                        info.setPerson(personInfo);
                        info.setOrgDep(adminOrgUnitInfo);//id
                        info.setPerfPlan(perfPeriodInfo);//id
                        zero = zero.add(itemWeight);

                        if (index == mapList.size() - 1) {
                            zero = zero.divide(BigDecimal.valueOf(mapList.size()));
                        }
                        index++;
                        info.setPerPojectSum(zero);//Ÿϵ
                        entry.setParticipate(projectManagementInfo);//Ŀid
                        entry.setPerson(perInfo);//Ŀ
                        entry.setProjectkPicoeff(projectkPicoeff);//ĿЧ
                        entry.setProjectRole(projectRoleInfo);//ɫid
                        entry.setProjectPerformance(projectPerformance);//ĿЧ
                        entry.setItemWeight(itemWeight);//Ȩ÷
                        info.getEntrys().add(entry);
                    }
                    PerformanProjectTwoFactory.getLocalInstance(ctx).save(info);
                }
            }
        } catch (Exception e) {
            e.printStackTrace();
            throw new BOSException(e);
        }
        return callService;
    }
}
