package com.kingdee.eas.custom.performanceScoring.handler;

import com.kingdee.bos.BOSException;
import com.kingdee.bos.Context;
import com.kingdee.bos.dao.ormapping.ObjectUuidPK;
import com.kingdee.bos.util.BOSUuid;
import com.kingdee.eas.basedata.org.AdminOrgUnitInfo;
import com.kingdee.eas.basedata.person.PersonInfo;
import com.kingdee.eas.common.EASBizException;
import com.kingdee.eas.framework.CoreBaseCollection;
import com.kingdee.eas.hr.perf.PerformanceMiddleCollection;
import com.kingdee.eas.hr.perf.PerformanceMiddleFactory;
import com.kingdee.eas.hr.perf.PerformanceMiddleInfo;
import com.kingdee.eas.hr.perf.app.documentType;
import com.kingdee.eas.util.app.DbUtil;
import com.kingdee.jdbc.rowset.IRowSet;
import com.kingdee.shr.base.syssetting.api.bean.BatchMessageTipsBody;
import com.kingdee.shr.base.syssetting.api.bean.BatchMessageTipsHeader;
import com.kingdee.shr.base.syssetting.context.SHRContext;
import com.kingdee.shr.base.syssetting.exception.SHRWebException;
import com.kingdee.shr.base.syssetting.exception.ShrWebBizException;
import com.kingdee.shr.base.syssetting.web.json.JSONUtils;
import com.kingdee.shr.perfweb.app.base.evalplan.*;
import com.kingdee.shr.perfweb.app.base.evalrule.WFNodeDefInfo;
import com.kingdee.shr.perfweb.app.base.indecator.PerfIndecatorCollection;
import com.kingdee.shr.perfweb.app.base.indecator.PerfIndecatorFactory;
import com.kingdee.shr.perfweb.app.common.YesOrNoEnum;
import com.kingdee.shr.perfweb.app.exception.SHRPerfWebBizException;
import com.kingdee.shr.perfweb.app.resource.SHRPerfWebResource;
import com.kingdee.shr.perfweb.app.workflow.*;
import com.kingdee.shr.perfweb.bean.PerfScoreBatchSaveBean;
import com.kingdee.shr.perfweb.bean.PerfScoreBean;
import com.kingdee.shr.perfweb.bean.PerfScoreList;
import com.kingdee.shr.perfweb.planexecute.handler.EvaResultSummaryManager4OrgListHandler;
import com.kingdee.shr.perfweb.util.GetEntityInfoUtils;
import com.kingdee.shr.perfweb.util.SHRPerfWebResourceUtil;
import com.kingdee.shr.perfweb.util.ServerResponseConst;
import org.apache.log4j.Logger;
import org.springframework.ui.ModelMap;
import org.springframework.util.CollectionUtils;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.io.FileInputStream;
import java.io.IOException;
import java.math.BigDecimal;
import java.sql.SQLException;
import java.util.*;

/**
 * @Description ֯˼ƻ˽
 * @Date 2024/12/26 15:34
 * @Created by 30489
 */
public class EvaResultSummaryManager4OrgListHandlerEx extends EvaResultSummaryManager4OrgListHandler {
    private static Logger logger = Logger.getLogger("com.kingdee.eas.custom.performanceScoring.handler.EvaResultSummaryManager4OrgListHandlerEx");

    private Properties propt = new Properties();
    public EvaResultSummaryManager4OrgListHandlerEx() {
        try {
            this.propt.load(new FileInputStream(System.getProperty("EAS_HOME") + "/server/properties/hty/configuration.properties"));
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    /**
     * ȡ֯
     * 1ȡ 
     * 2 ȡ ڵ㣬ʵ  ƴװ  List<PerfScoreList>
     * 3  Чм£ɾ
     *
     * @param request
     * @param response
     * @param modelMap
     * @throws SHRWebException
     * @throws BOSException
     * @throws EASBizException
     * @throws SQLException
     */
    public void getSubmitScoreClickEventAction(HttpServletRequest request, HttpServletResponse response, ModelMap modelMap) throws SHRWebException, BOSException, EASBizException, SQLException {
        boolean mark = false;
        Context ctx = SHRContext.getInstance().getContext();
        //
        String satisfactionNumber = propt.getProperty("satisfactionNumber");//ָ
        PerfIndecatorCollection perfIndecatorCollection = PerfIndecatorFactory.getLocalInstance(ctx).getPerfIndecatorCollection("where number = '"+satisfactionNumber+"'");
        if (perfIndecatorCollection.size() ==0){
            throw new ShrWebBizException("δҵָ:"+satisfactionNumber+"飡");
        }
        Map<String, Object> res = new HashMap();
        String periodId = request.getParameter("id");//id
        BatchMessageTipsHeader batchMessageTipsHeader = new BatchMessageTipsHeader();
        String billIds = "";
        int success = 0;
        int failure = 0;
        //֯Ч
        OrgEvaResultSummaryCollection orgEvaResultSummaryCollection = OrgEvaResultSummaryFactory.getLocalInstance(ctx).
                getOrgEvaResultSummaryCollection("where period = '"+periodId+"' and sum.FSUMSCORE is not null ");
        List<PerfScoreList> perfScoreListAll = new ArrayList<PerfScoreList>();
        CoreBaseCollection coreBaseCollectionUpdate = new CoreBaseCollection();
        CoreBaseCollection coreBaseCollectionSave = new CoreBaseCollection();
        //洢ȡ֯ǰ ֺܷ͵ȼ
        Map<String, String> perMap = new HashMap<String, String>();

        for (int i = 0; i < orgEvaResultSummaryCollection.size(); i++) {
            List<PerfScoreBean> scoreList = new ArrayList<PerfScoreBean>();
            PerfScoreList perfScoreList = new PerfScoreList();
            OrgEvaResultSummaryInfo info = orgEvaResultSummaryCollection.get(i);
            String billId = info.getId().toString();
            billIds += billId + ",";
            BatchMessageTipsBody body = new BatchMessageTipsBody();
            body.setId(billId);
            PerfEvaObjectInfo evaObj = info.getEvaObj();//
            String orgNumber = info.getAdminOrgNumber();
            double sumScore = info.getSumScore();//ܷ
            String gradeLevel = info.getGradeLevel();//ܷ
            perMap.put(orgNumber ,sumScore + "," + gradeLevel);//洢ȡ֯ǰ ֺܷ͵ȼ
            String evaObjId = evaObj.getId().toString(); //id

            //Ż
            String getTargetDataSql = getTargetDataSql(evaObjId,satisfactionNumber,periodId); // ȡ ڵ㣬ʵ
            IRowSet iRowSet = DbUtil.executeQuery(ctx, getTargetDataSql);
            int index = 0 ;
            Map<String, Object> mapSum = new HashMap<String, Object>();
            Map<String, Object> middleMap = new HashMap<String, Object>();
            BigDecimal addSum = BigDecimal.ZERO;
            BigDecimal subtractSum = BigDecimal.ZERO;
            if (iRowSet.size() == 0){
                throw new ShrWebBizException("ÿδѯ֯ȵĽڵʵУϵϵͳԱ");
            }
            while (iRowSet.next()){
                PerfScoreBean perfScoreBean = new PerfScoreBean();
                String score = iRowSet.getString("score") != null ? iRowSet.getString("score") : "0";
                BigDecimal scoreBig = BigDecimal.valueOf(Double.valueOf(score)); //ʵ÷
                String targetId = iRowSet.getString("targetId");//ָid
                String evaName = iRowSet.getString("evaName");//ָ
                String nodEvaId = iRowSet.getString("nodEvaId");//id
                String nodeId = iRowSet.getString("nodeId");//ڵid
                String nodeScore = iRowSet.getString("nodeScore");//ڵܷ
                String nodeGrade = iRowSet.getString("nodeGrade");//ڵȼ
                String orgId = iRowSet.getString("orgId");//֯id

                perfScoreBean.setScoreOrRate("0");
                if (index == 0){
                    ++success;
                    getScoringSumData(periodId,ctx,mapSum,orgId);
                    getMiddleData(ctx, periodId,orgId,middleMap);
                }
                index ++;
                boolean flaySum = (boolean) mapSum.get("flaySum");// ֯ true жӦ
                boolean flay = (boolean) middleMap.get("flay");// Чм true жӦ
                if (!flaySum){
                    mark = true;
                }

//                if (!(flaySum || flay)){  //֯ Чмûѯ
//                    throw new ShrWebBizException("δҵÿڵĿ˽ȵ÷֣");
//                }
                addSum = (BigDecimal)mapSum.get("addSum"); //֯ ӷ
                subtractSum = (BigDecimal)mapSum.get("subtractSum");//֯ 
                if (flay){ //
                    BigDecimal plusesScore = (BigDecimal) middleMap.get("addSum");//Чм ӷ
                    BigDecimal seducedScore = (BigDecimal) middleMap.get("subtractSum");//Чм 
                    if ("ӷ".equals(evaName)){
                        perfScoreBean.setScore(String.valueOf(scoreBig.subtract(plusesScore).add(addSum)));
                    }else {
                        if (scoreBig.compareTo(BigDecimal.ZERO) == 0 ){
                            perfScoreBean.setScore(String.valueOf(scoreBig.add(subtractSum)));
                        }else {
                            perfScoreBean.setScore(String.valueOf(scoreBig.subtract(seducedScore).add(subtractSum)));
                        }
                    }
                }else {
                    if ("ӷ".equals(evaName)){
                        perfScoreBean.setScore(String.valueOf(addSum.add(scoreBig)));
                    }else {
                        perfScoreBean.setScore(String.valueOf(subtractSum.add(scoreBig)));
                    }
                }
                body.setMuitTipsState(Boolean.TRUE);
                body.setMuitTipsMessage("ȡɹ֯ȼӷΪ" + addSum +";֯ȼΪ" + subtractSum);
                batchMessageTipsHeader.addResult(body);
                perfScoreBean.setNodeGrade("0");
                perfScoreBean.setComment("0");
                perfScoreBean.setActValue("0");
                perfScoreBean.setTargetVale("0");
                perfScoreBean.setTargetVale("0");
                perfScoreBean.setDescription("0");
                perfScoreBean.setIndicatorId(targetId + "Itag0");
                perfScoreBean.setExtendInfo(new HashMap<String, Map<String, String>>());
                scoreList.add(perfScoreBean);
                perfScoreList.setEvaObj(nodEvaId);
                perfScoreList.setGradeTaskNode(nodeId);
                perfScoreList.setWholeGrade(nodeGrade);
                perfScoreList.setSumScore(nodeScore);
            }
            perfScoreList.setIsEditGrade("1");
            perfScoreList.setNeedScore("1");
            perfScoreList.setWholeComment("wesfwertwe");
            perfScoreList.setScoreList(scoreList);
            perfScoreListAll.add(perfScoreList);

        }
        //Ϊϵͳ ύ׼
        String isRealSave = null;
        if (CollectionUtils.isEmpty(perfScoreListAll)) {
            JSONUtils.writeJson(response, res);
        } else {
            for (int i = 0; i < perfScoreListAll.size(); i++) {
                String evaObj = ((PerfScoreList)perfScoreListAll.get(i)).getEvaObj();
                PerfEvaObjectInfo info = GetEntityInfoUtils.getPerfEvaObjectInfo(ctx, evaObj);
                Set<String> nodeTask = new HashSet();
                Map<String, String> nodeScore = new HashMap();
                List<PerfScoreList> normalScoreList = new ArrayList();
                List<PerfScoreBatchSaveBean> sumScoreList = new ArrayList();
                Iterator var16 = perfScoreListAll.iterator();

                while(var16.hasNext()) {
                    PerfScoreList pl = (PerfScoreList)var16.next();
                    PerfScoreBatchSaveBean bean = new PerfScoreBatchSaveBean();
                    bean.setGradeTaskNodeInstID(pl.getGradeTaskNode());
                    bean.setWholeComment(pl.getWholeComment());
                    bean.setNodeGrade(pl.getWholeGrade());
                    bean.setNodeSumScore(pl.getSumScore());
                    bean.setEvaObj(pl.getEvaObj());
                    if ("3".equals(pl.getNeedScore())) {
                        sumScoreList.add(bean);
                    } else {
                        normalScoreList.add(pl);
                    }
                }

                String saveStatus;
                Map map;
                if (sumScoreList.size() > 0) {
                    IPerfWorkFlowFacade iPerfWorkFlowFacade = PerfWorkFlowFacadeFactory.getLocalInstance(ctx);
                    map = iPerfWorkFlowFacade.saveNodeSumScoreAndGrade(sumScoreList);
                    String msg = SHRPerfWebResourceUtil.getRes(SHRPerfWebResource.SAVESUCCESS, ctx);
                    if (map.get("code").toString().equalsIgnoreCase(ServerResponseConst.SUCCESS)) {
                        res.put("result", "200");
                    } else {
                        res.put("result", "500");
                        saveStatus = map.get("code").toString();
                        if (ServerResponseConst.FAILED.equals(saveStatus)) {
                            msg = SHRPerfWebResourceUtil.getRes(SHRPerfWebResource.ALLHASSCOREFORMULAR, ctx);
                        } else if ("400".equals(saveStatus)) {
                            msg = SHRPerfWebResourceUtil.getRes(SHRPerfWebResource.OVERSUMRANGE, ctx);
                        } else if ("999".equals(saveStatus)) {
                            msg = SHRPerfWebResourceUtil.getRes(SHRPerfWebResource.LESSTHANQUANTITYS, ctx);
                        } else if ("LESSLOWLIMIT".equals(saveStatus)) {
                            msg = (new SHRPerfWebBizException(SHRPerfWebBizException.SCOREOVERMIN2)).getMessage();
                        } else if (ServerResponseConst.INVALID.equals(saveStatus)) {
                            msg = SHRPerfWebResourceUtil.getRes(SHRPerfWebResource.CHANGEHANDLER, ctx);
                        }
                    }

                    res.put("msg", msg);
                    res.put("maxCanPut", map.get("maxCanPut"));
                    res.put("gradetaskNode", sumScoreList);
                    res.put("nodeSumScore", ((PerfScoreBatchSaveBean)sumScoreList.get(0)).getNodeSumScore());
                    res.put("nodeGrade", ((PerfScoreBatchSaveBean)sumScoreList.get(0)).getNodeGrade());
                    res.put("detail", "");
                    if ("500".equals(res.get("result"))) {
                        JSONUtils.writeJson(response, res);
                        return;
                    }
                }

                if (normalScoreList.size() > 0) {
                    PerfWorkFlowFacadeControllerBean.getInstance().calculateAndSaveScore(ctx, normalScoreList, res, isRealSave, nodeTask, nodeScore);
                }

                StringBuffer msgInfo = new StringBuffer("");
                if (info.getCanAdjustEvaluer().getValue() == 1) {
                    try {
                        map = this.getAreaBaseNameByNodeTaskInst(nodeTask, evaObj);
                        Iterator<String> it = nodeScore.keySet().iterator();

                        while(it.hasNext()) {
                            saveStatus = (String)it.next();
                            String[] grade = ((String)nodeScore.get(saveStatus)).split("#");
                            String areaName = (String)map.get(saveStatus);
                            GradeTaskNodeInstInfo gtnInfo = GetEntityInfoUtils.getGradeTaskNodeInstInfoById(ctx, saveStatus);
                            WFNodeDefInfo wfNodeInfo = GetEntityInfoUtils.getWFNodeDefInfo(ctx, gtnInfo.getWfNode().getId().toString());
                            if (grade.length > 1) {
                                msgInfo.append(areaName);
                                if (!wfNodeInfo.getNeedScore().getValue().equals("0")) {
                                    msgInfo.append(SHRPerfWebResourceUtil.getRes(SHRPerfWebResource.SCOREIS, ctx)).append(":").append(grade[0]).append(",");
                                }

                                if (wfNodeInfo.getPerfGradeEvaluate().getValue().equals("1")) {
                                    msgInfo.append(SHRPerfWebResourceUtil.getRes(SHRPerfWebResource.GRADEIS, ctx)).append(":").append(grade[1]).append("");
                                }
                            } else {
                                String gradeStr = "";
                                if (grade.length > 0) {
                                    gradeStr = grade[0];
                                }

                                msgInfo.append(areaName).append(SHRPerfWebResourceUtil.getRes(SHRPerfWebResource.SCOREIS, ctx)).append(":").append(gradeStr);
                                if (wfNodeInfo.getPerfGradeEvaluate().getValue().equals("1")) {
                                    msgInfo.append(",").append(SHRPerfWebResourceUtil.getRes(SHRPerfWebResource.GRADEIS, ctx)).append(":");
                                }
                            }
                        }
                    } catch (BOSException var25) {
                        logger.error("", var25);
                    }
                }
                res.put("detail", msgInfo.toString());
                PerfScoreList scoreList = (PerfScoreList)perfScoreListAll.get(i);
                String gradeTaskNodeId = scoreList.getGradeTaskNode();
                GradeTaskNodeInstInfo gradeTaskNodeInstInfo = GetEntityInfoUtils.getGradeTaskNodeInstInfoById(ctx, gradeTaskNodeId);
                String scoreStatus = "1";
                if (gradeTaskNodeInstInfo != null) {
                    if (gradeTaskNodeInstInfo.getScoreStatus() != null) {
                        scoreStatus = gradeTaskNodeInstInfo.getScoreStatus().getValue();
                    }
                    PerfWorkFlowFacadeControllerBean.getInstance().submitScore(ctx, scoreList);
                }

            }

            // ɼЧм
            Map<String, String> map = new HashMap<String, String>();
            getPerData(ctx,periodId,map);//ȡЧݣmap,Է¼idΪkey
            logger.error("EvaResultSummaryManager4OrgListHandlerExEvaResultSummaryManager4OrgListHandlerEx");
            logger.error(map);
            for (String orgNumber : perMap.keySet()) {
                String value = perMap.get(orgNumber);
                String[] split1 = value.split(",");
                String value0 = split1[0];//ԭܷ
                String value1 = split1[1];//ԭȼ
                //м
                PerformanceMiddleCollection performanceMiddleCollection = PerformanceMiddleFactory.getLocalInstance(ctx).
                        getPerformanceMiddleCollection("select *,orgDep.number,orgDep.id where orgDep.number = '" + orgNumber + "' and perfPlan = '"+periodId+"'");

                if (performanceMiddleCollection.size() > 0 ){
                    for (int i = 0; i < performanceMiddleCollection.size(); i++) {
                        PerformanceMiddleInfo performanceMiddleInfo = performanceMiddleCollection.get(i);
                        String sourceBillId = performanceMiddleInfo.getSourceBillId(); // Чܷ¼id
                        String valueStr = map.get(sourceBillId);
                        if (valueStr != null){
                            String[] split = valueStr.split(",");
                            String s0 = split[0];//id
                            String s1 = split[1];//Աid
                            String s2 = split[2];// id
                            String s3 = split[3];//
                            String s4 = split[4];//˽ȼ
                            performanceMiddleInfo.setFraction(BigDecimal.valueOf(Double.valueOf(s3)));
                            performanceMiddleInfo.setOriginalfraction(BigDecimal.valueOf(Double.valueOf(value0)));
                            performanceMiddleInfo.setOriginalgrade(value1);
                            performanceMiddleInfo.setGrade(s4);
                            coreBaseCollectionUpdate.add(performanceMiddleInfo);
                        }else {//Чͨʱ
                            PerformanceMiddleFactory.getLocalInstance(ctx).delete(new ObjectUuidPK(performanceMiddleInfo.getId()));
                        }
                    }
                }else {
                    for (String key : map.keySet()) {
                        PerformanceMiddleInfo performanceMiddleInfo = new PerformanceMiddleInfo();
                        String mapValue = map.get(key);
                        String[] split = mapValue.split(",");
                        String s5 = split[5];//ű
                        if (s5.equals(orgNumber)){
                            String s0 = split[0];//id
                            String s1 = split[1];//Աid
                            String s2 = split[2];// id
                            String s3 = split[3];//¼Ӽ
                            String s4 = split[4];//˽ȼ
                            String s6 = split[6];//ԭid
                            String s7 = split[7];//
                            PerfPeriodInfo perfPeriodInfo = new PerfPeriodInfo();
                            perfPeriodInfo.setId(BOSUuid.read(s0));
                            performanceMiddleInfo.setPerfPlan(perfPeriodInfo);
                            PersonInfo personInfo = new PersonInfo();
                            personInfo.setId(BOSUuid.read(s1));
                            performanceMiddleInfo.setPerson(personInfo);
                            AdminOrgUnitInfo adminOrgUnitInfo = new AdminOrgUnitInfo();
                            adminOrgUnitInfo.setId(BOSUuid.read(s2));
                            performanceMiddleInfo.setOrgDep(adminOrgUnitInfo);
                            performanceMiddleInfo.setType(documentType.Satisfaction);
                            performanceMiddleInfo.setSourceBillId(s6);
                            performanceMiddleInfo.setFraction(BigDecimal.valueOf(Double.valueOf(s3)));
                            performanceMiddleInfo.setOriginalfraction(BigDecimal.valueOf(Double.valueOf(value0)));
                            performanceMiddleInfo.setOriginalgrade(value1);
                            performanceMiddleInfo.setGrade(s4);
                            performanceMiddleInfo.setPerformance(s7);
                            coreBaseCollectionSave.add(performanceMiddleInfo);
                        }
                    }
                }
            }
            if (mark){
                throw new ShrWebBizException("ҲӦļЧֻܵݣ飡");
            }
            PerformanceMiddleFactory.getLocalInstance(ctx).updateBatchData(coreBaseCollectionUpdate);
            PerformanceMiddleFactory.getLocalInstance(ctx).saveBatchData(coreBaseCollectionSave);
            //JSONUtils.writeJson(response, res);
            billIds = billIds.substring(0, billIds.length() - 1);
            batchMessageTipsHeader.setBillId(billIds);
            batchMessageTipsHeader.setFailureCount(failure);
            batchMessageTipsHeader.setSuccessCount(success);
            this.writeSuccessData(batchMessageTipsHeader);

        }
    }

    public Map<String, String> getAreaBaseNameByNodeTaskInst(Set nodeTakSet, String evaObj) throws BOSException {
        Context ctx = SHRContext.getInstance().getContext();
        Map<String, String> map = new HashMap();
        GradeTargetInstCollection coll = GetEntityInfoUtils.getGradeTargetInstCollectionByNodeInst(ctx, nodeTakSet, evaObj);
        Set<String> exist = new HashSet();

        for(int i = 0; i < coll.size(); ++i) {
            if (map.get(coll.get(i).getGradeTaskNode().getId().toString()) != null) {
                if (!exist.contains(coll.get(i).getAreaBase().getId().toString()) && coll.get(i).getEvaObj().getCanAdjustEvaluer().getValue() != 0) {
                    String areaName = (String)map.get(coll.get(i).getGradeTaskNode().getId().toString());
                    areaName = areaName + "," + coll.get(i).getAreaBase().getName();
                    map.put(coll.get(i).getGradeTaskNode().getId().toString(), areaName);
                    exist.add(coll.get(i).getAreaBase().getId().toString());
                }
            } else if (coll.get(i).getEvaObj().getCanAdjustEvaluer().getValue() == 0) {
                map.put(coll.get(i).getGradeTaskNode().getId().toString(), "");
            } else {
                map.put(coll.get(i).getGradeTaskNode().getId().toString(), coll.get(i).getAreaBase().getName());
                exist.add(coll.get(i).getAreaBase().getId().toString());
            }
        }

        GradeTaskNodeInstCollection nodecoll = GetEntityInfoUtils.getGradeTaskNodeInstCollByEvaObj(ctx, evaObj);
        PerfEvaObjectInfo evaInfo = GetEntityInfoUtils.getPerfEvaObjectInfo(ctx, evaObj);
        PerfEvaObjMatrixWorkFlowInstCollection matriInfotColl = PerfEvaObjMatrixWorkFlowInstFactory.getLocalInstance(ctx).getPerfEvaObjMatrixWorkFlowInstCollection("select *, areaBase.name where evaObj ='" + evaObj + "'");
        PerfPeriodInfo perfPeriod = evaInfo.getPeriod();
        String perfPlanId = perfPeriod.getPerfPlan().getId().toString();
        String perfRuleId = perfPeriod.getPerfRule().getId().toString();
        YesOrNoEnum isHistoryUpdate = perfPeriod.getIsHistoryUpdate();
        PerfEvaObjectMatrixWorkFlowCollection matriWorkFlow = null;
        matriWorkFlow = PerfEvaObjectMatrixWorkFlowFactory.getLocalInstance(ctx).getPerfEvaObjectMatrixWorkFlowCollection("select *, areaBase.name where perfplan = '" + perfPlanId + "' and perfRule = '" + perfRuleId + "'");
        if (matriWorkFlow.isEmpty() && isHistoryUpdate.getValue() == 1) {
            matriWorkFlow = PerfEvaObjectMatrixWorkFlowFactory.getLocalInstance(ctx).getPerfEvaObjectMatrixWorkFlowCollection("select *, areaBase.name where perfplan = '" + perfPlanId + "' and perfRule is null");
        }

        Map<String, String> worfFlowAreaMap = new HashMap();

        int i;
        for(i = 0; i < matriInfotColl.size(); ++i) {
            PerfEvaObjMatrixWorkFlowInstInfo matriInfo = matriInfotColl.get(i);
            if (org.apache.commons.lang3.StringUtils.isEmpty((CharSequence)worfFlowAreaMap.get(matriInfo.getWorkflow().getId().toString()))) {
                worfFlowAreaMap.put(matriInfo.getWorkflow().getId().toString(), matriInfo.getAreaBase().getName());
            }
        }

        for(i = 0; i < matriWorkFlow.size(); ++i) {
            PerfEvaObjectMatrixWorkFlowInfo matriWorkFlowInfo = matriWorkFlow.get(i);
            if (org.apache.commons.lang3.StringUtils.isEmpty((CharSequence)worfFlowAreaMap.get(matriWorkFlowInfo.getWorkflow().getId().toString()))) {
                worfFlowAreaMap.put(matriWorkFlowInfo.getWorkflow().getId().toString(), matriWorkFlowInfo.getAreaBase().getName());
            }
        }

        for(i = 0; i < nodecoll.size(); ++i) {
            GradeTaskNodeInstInfo info = nodecoll.get(i);
            if (org.apache.commons.lang3.StringUtils.isEmpty((CharSequence)map.get(info.getId().toString()))) {
                String workFlowId = info.getWfNode().getWorkflow().getId().toString();
                map.put(info.getId().toString(), worfFlowAreaMap.get(workFlowId));
            }
        }

        return map;
    }


    /**
     *  ȡڵ㣬ʵ
     * @param evaObjId 
     * @return
     */
    public String getTargetDataSql(String evaObjId,String satisfactionNumber,String periodId){
        StringBuilder sql = new StringBuilder();
        sql.append("SELECT").append("\n");
        sql.append("inst.FTARGETSCORE score,").append("\n");
        sql.append("ind.fid targetId,").append("\n");
        sql.append("eva.FNAME_L2 evaName,").append("\n");
        sql.append("node.FEVAOBJID nodEvaId,").append("\n");
        sql.append("node.fid nodeId,").append("\n");
        sql.append("node.FNODESUMSCORE nodeScore,").append("\n");
        sql.append("node.FNODEGRADE nodeGrade,").append("\n");
        sql.append("org.fid orgId").append("\n");
        sql.append("from T_EVA_GradeTaskNodeInst node").append("\n");
        sql.append("left join T_EVA_GradeTargetInst inst on node.fid = inst.FGRADETASKNODEID").append("\n");
        sql.append("left join T_EVA_IndicatorTarget ind on ind.fid = inst.FTARGET").append("\n");
        sql.append("left join T_PEF_PerfIndecator per on per.fid = ind.FINDECATOR").append("\n");
        sql.append("left join T_EVA_EvaluFormAreaBase eva on eva.fid = inst.FAREABASEID").append("\n");
        sql.append("left join T_EVA_PerfEvaObject obj on obj.fid = node.FEVAOBJID").append("\n");
        sql.append("left join T_org_admin org on org.fid = obj.FEVALUORGADMINID").append("\n");
        sql.append("inner join (").append("\n");
        sql.append("    select max(FWFLEVEL) max from T_EVA_GradeTaskNodeInst  where FPERIODID='"+periodId+"'").append("\n");
        sql.append(") as a on a.max=node.FWFLEVEL ").append("\n");
        //and FWFLEVEL = (select max(FWFLEVEL) from T_EVA_GradeTaskNodeInst)
        sql.append("where node.FEVAOBJID = '"+evaObjId+"' and per.Fnumber = '"+satisfactionNumber+"'\n").append("\n");//and ind.FNAME_L1 = '֯'
        return sql.toString();
    }


    public void getPerData(Context ctx,String periodId,Map<String, String> map) throws BOSException, SQLException {
        StringBuilder sql = new StringBuilder();
        sql.append("SELECT").append("\n");
        sql.append("ind.CFPERFORAPPRAISALI perfPlan,").append("\n");
        sql.append("sse.CFCHARGEDEPPERSONI personId,").append("\n");
        sql.append("sse.CFFIRSTDEPID depId,").append("\n");
        sql.append("org.Fnumber depNumber,").append("\n");
        sql.append("sse.fid id,").append("\n");
        sql.append("sse.CFADDMULTIPLYPART fraction,").append("\n");
        sql.append("eva.FSUMSCORE,eva.FGRADELEVEL,eva.FPNAME").append("\n");
        sql.append("FROM CT_PF_PerformanceScoringSum ind").append("\n");
        sql.append("left join CT_PF_PerformanceSSE sse on sse.FPARENTID = ind.fid ").append("\n");
        sql.append("left join T_org_admin org on org.fid = sse.CFFIRSTDEPID ").append("\n");
        sql.append("left join T_EVA_OrgEvaResultSummary eva on eva.FPERIODID = ind.CFPERFORAPPRAISALI").append("\n");
        sql.append("where ind.CFPERFORAPPRAISALI = '"+periodId+"' and ind.FBILLSTATE = 3").append("\n");
        IRowSet iRowSet = DbUtil.executeQuery(ctx, sql.toString());

        while (iRowSet.next()){
            String perfPlan = iRowSet.getString("perfPlan");//id
            String personId = iRowSet.getString("personId");//Աid
            String depId = iRowSet.getString("depId"); // id
            String depNumber = iRowSet.getString("depNumber");//ű
            String id = iRowSet.getString("id");// Ч¼id
            String fraction = iRowSet.getString("fraction");//¼Ӽ
            String sumScore = iRowSet.getString("FSUMSCORE");//˽
            String gradeLevel = iRowSet.getString("FGRADELEVEL");//˽ȼ
            String pName = iRowSet.getString("FPNAME");//
            map.put(id, perfPlan+","+personId+","+depId+","+fraction + "," + gradeLevel + "," + depNumber + "," + id + "," + pName);
        }


    }

    /**
     * ˽ȵ÷
     * @param periodId
     * @param ctx
     * @param mapSum
     * @throws SQLException
     * @throws BOSException
     * @throws ShrWebBizException
     */
    public void getScoringSumData(String periodId,Context ctx,Map<String, Object> mapSum,String orgId) throws SQLException, BOSException, ShrWebBizException {
        StringBuilder sql = new StringBuilder();
        sql.append("SELECT").append("\n");
        sql.append("CFADDMULTIPLYPART sum").append("\n");
        sql.append("FROM CT_PF_PerformanceScoringSum per").append("\n");
        //sql.append("left join CT_PF_PerformanceScoringSum per on eva.FPERIODID = per.CFPERFORAPPRAISALI").append("\n");
        sql.append("left join CT_PF_PerformanceSSE sse on sse.FPARENTID = per.fid").append("\n");
        sql.append("left join T_org_admin org on org.fid = sse.CFFIRSTDEPID").append("\n");
        sql.append("where per.CFPERFORAPPRAISALI = '"+periodId+"' and org.fid = '"+orgId+"' and per.FBILLSTATE = 3").append("\n");
        IRowSet iRowSet = DbUtil.executeQuery(ctx, sql.toString());
        boolean flaySum = false;
        BigDecimal addSum = BigDecimal.ZERO;
        BigDecimal subtractSum = BigDecimal.ZERO;
        while (iRowSet.next()){
            flaySum = true;
            BigDecimal sum = iRowSet.getBigDecimal("sum");
            if (sum.compareTo(BigDecimal.ZERO) >0){
                addSum = addSum.add(sum);
            }else {
                subtractSum = subtractSum.add(sum);
            }
        }
        mapSum.put("addSum",addSum);
        mapSum.put("subtractSum",subtractSum);
        mapSum.put("flaySum",flaySum);
    }

    /**
     * Чм
     * @param ctx
     * @param periodId id
     * @param depId
     * @param map
     * @return
     * @throws BOSException
     */
    public Map<String, Object> getMiddleData(Context ctx,String periodId,String depId,Map<String, Object> map) throws BOSException {
        PerformanceMiddleCollection performanceMiddleCollection = PerformanceMiddleFactory.getLocalInstance(ctx).
                getPerformanceMiddleCollection("where perfPlan = '" + periodId + "' and orgDep = '"+depId+"'");
        BigDecimal addSum = BigDecimal.ZERO;
        BigDecimal subtractSum = BigDecimal.ZERO;
        boolean flay = false;
        for (int i = 0; i < performanceMiddleCollection.size(); i++) {
            flay = true;
            PerformanceMiddleInfo performanceMiddleInfo = performanceMiddleCollection.get(i);
            BigDecimal fraction = performanceMiddleInfo.getFraction();
            if (fraction.compareTo(BigDecimal.ZERO) >0){
                addSum = addSum.add(fraction);
            }else {
                subtractSum = subtractSum.add(fraction);
            }
        }
        map.put("addSum",addSum);
        map.put("subtractSum",subtractSum);
        map.put("flay",flay);
        return map;
    }



}
