package com.kingdee.eas.custom.performanceScoring.handler;

import com.kingdee.bos.Context;
import com.kingdee.bos.metadata.entity.EntityViewInfo;
import com.kingdee.bos.metadata.entity.FilterInfo;
import com.kingdee.bos.metadata.entity.FilterItemInfo;
import com.kingdee.bos.metadata.entity.SelectorItemCollection;
import com.kingdee.bos.metadata.query.util.CompareType;
import com.kingdee.eas.framework.CoreBaseInfo;
import com.kingdee.eas.hr.ats.AtsUtil;
import com.kingdee.eas.hr.perf.*;
import com.kingdee.shr.base.syssetting.context.SHRContext;
import com.kingdee.shr.base.syssetting.exception.SHRWebException;
import com.kingdee.shr.base.syssetting.exception.ShrWebBizException;
import com.kingdee.shr.base.syssetting.web.handler.DEPCustomBillEditHandler;
import org.apache.log4j.Logger;
import org.springframework.ui.ModelMap;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.text.SimpleDateFormat;

/**
 * @author qingwu
 * @date 2025/2/20
 * @apiNote
 */
public class PerformanProjectTwoDEPEditHandler extends DEPCustomBillEditHandler {

    Logger logger = Logger.getLogger("com.kingdee.eas.custom.performanceScoring.handler.PerformanProjectTwoDEPEditHandler");
    //yyyy-MM-dd HH:mm:ss
    private static SimpleDateFormat format = new SimpleDateFormat("yyyy-MM-dd HH:mm");

    /***
     * ύЧ
     * @param request
     * @param response
     * @param modelMap
     * @throws SHRWebException
     */
    @Override
    public void submitEffectAction(HttpServletRequest request, HttpServletResponse response, ModelMap modelMap) throws SHRWebException {
        logger.error("submitEffectAction------------");
        //Ϣ
        CoreBaseInfo model = (CoreBaseInfo) request.getAttribute("dynamic_model");
        Context ctx = SHRContext.getInstance().getContext();
        try {
            IPerformanProjectTwo iPerformanProjectTwo = PerformanProjectTwoFactory.getLocalInstance(ctx);
            PerformanProjectTwoInfo performanProjectTwoInfo = (PerformanProjectTwoInfo) model;
            String personId = performanProjectTwoInfo.getPerson().getId().toString();
            //˽
            SelectorItemCollection sic = new SelectorItemCollection();
            sic.add("*");
            sic.add("person.id");
            sic.add("person.name");
            FilterInfo filterInfo = new FilterInfo();
            filterInfo.getFilterItems().add(new FilterItemInfo("person", personId, CompareType.EQUALS));
            filterInfo.getFilterItems().add(new FilterItemInfo("billState", AtsUtil.toSet("2,3,4"), CompareType.INCLUDE));
            filterInfo.getFilterItems().add(new FilterItemInfo("endDate", performanProjectTwoInfo.getStartDate(), CompareType.GREATER_EQUALS));
            filterInfo.getFilterItems().add(new FilterItemInfo("startDate", performanProjectTwoInfo.getEndDate(), CompareType.LESS_EQUALS));
            EntityViewInfo entityViewInfo = EntityViewInfo.getInstance(filterInfo, sic, null);
            PerformanProjectTwoCollection performanProjectTwoCollection = iPerformanProjectTwo.getPerformanProjectTwoCollection(entityViewInfo);
            if (performanProjectTwoCollection.size() > 0) {
                PerformanProjectTwoInfo info = performanProjectTwoCollection.get(0);
                throw new ShrWebBizException("ǰԱ" + info.getPerson().getName() + "ʱ䷶Χݣȴʷݱţ" + info.getNumber() + "");
            }
        } catch (Exception e) {
            e.printStackTrace();
            throw new ShrWebBizException(e);
        }
        super.submitEffectAction(request, response, modelMap);
    }
}
