package com.kingdee.eas.custom.performanceScoring.handler;

import com.aliyun.odps.utils.StringUtils;
import com.kingdee.bos.BOSException;
import com.kingdee.bos.Context;
import com.kingdee.bos.dao.IObjectPK;
import com.kingdee.bos.util.BOSUuid;
import com.kingdee.eas.base.permission.UserInfo;
import com.kingdee.eas.basedata.org.AdminOrgUnitInfo;
import com.kingdee.eas.basedata.org.HROrgUnitInfo;
import com.kingdee.eas.basedata.person.PersonInfo;
import com.kingdee.eas.framework.CoreBaseInfo;
import com.kingdee.eas.hr.emp.PersonPositionInfo;
import com.kingdee.eas.hr.perf.PerformanceScoringCollection;
import com.kingdee.eas.hr.perf.PerformanceScoringFactory;
import com.kingdee.eas.hr.perf.PerformanceScoringInfo;
import com.kingdee.eas.util.app.ContextUtil;
import com.kingdee.eas.util.app.DbUtil;
import com.kingdee.jdbc.rowset.IRowSet;
import com.kingdee.shr.ats.web.util.SHRBillUtil;
import com.kingdee.shr.base.syssetting.context.SHRContext;
import com.kingdee.shr.base.syssetting.exception.ShrWebBizException;
import com.kingdee.shr.base.syssetting.web.handler.DEPCustomBillEditHandler;
import com.kingdee.shr.perfweb.app.base.evalplan.PerfPeriodInfo;
import org.apache.log4j.Logger;
import com.kingdee.shr.base.syssetting.exception.SHRWebException;
import org.springframework.ui.ModelMap;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.util.*;

/**
 * @Description Ч_
 * @Date 2024/12/24 16:20
 * @Created by 30489
 */
public class PerformanceScoringDEPEditHandler extends DEPCustomBillEditHandler {
    private static Logger logger = Logger.getLogger("com.kingdee.eas.custom.server.performanceScoring.handler.PerformanceScoringDEPEditHandler");
    public void getPerfPeriodPersonAction(HttpServletRequest request, HttpServletResponse response, ModelMap modelMap) throws SHRWebException {
        Context ctx = SHRContext.getInstance().getContext();
        Map<String, Object> map = new HashMap<String, Object>();
        String billId = request.getParameter("id");
        try {
            List<Map<String,Object>> list = new ArrayList<Map<String,Object>>();
            StringBuilder sql = new StringBuilder();
            sql.append("select").append("\n");
            sql.append("org.fid orgId,").append("\n");
            sql.append("org.Fname_l2 orgName,").append("\n");
            sql.append("person.fid personId,").append("\n");
            sql.append("person.fname_l2 personName").append("\n");
            sql.append("from T_EVA_PerfEvaObject per ").append("\n");
            sql.append("left join T_EVA_PerfEvaluAdminResponsor eva on per.fid = eva.FEVAOBJID").append("\n");
            sql.append("left join T_ORG_admin org on org.fid = per.FEVALUORGADMINID").append("\n");
            sql.append("left join T_BD_person person on person.fid = eva.FPERSONID").append("\n");
            sql.append("where per.FPERIODID = '"+billId+"' and eva.fid is not null").append("\n");
            IRowSet iRowSet = DbUtil.executeQuery(ctx, sql.toString());
            while (iRowSet.next()){
                Map<String, Object> orgMap = new HashMap<String, Object>();
                Map<String, Object> personMap = new HashMap<String, Object>();
                Map<String, Object> integrationMap = new HashMap<String, Object>();
                String orgId = iRowSet.getString("orgId");
                String orgName = iRowSet.getString("orgName");
                String personId = iRowSet.getString("personId");
                String personName = iRowSet.getString("personName");
                orgMap.put("id",orgId);
                orgMap.put("name",orgName);
                personMap.put("id",personId);
                personMap.put("name",personName);
                integrationMap.put("firstDep",orgMap);
                integrationMap.put("chargeDepPerson",personMap);
                list.add(integrationMap);
            }
            //֯
            PersonInfo personInfo = SHRBillUtil.getCurrPersonInfo();
            String personId = personInfo.getId().toString();
            PersonPositionInfo personPositionInfo = SHRBillUtil.getAdminOrgUnitByPersonId(ctx, personId);
            AdminOrgUnitInfo personDep = personPositionInfo.getPersonDep();
            String depId = personDep.getId().toString();
            String depName = personDep.getName();
            Map<String, String> evaluationMap = new HashMap<String, String>();
            evaluationMap.put("id",depId);
            evaluationMap.put("name",depName);
            map.put("msg","success");
            map.put("list",list);
            map.put("evaluationMap",evaluationMap);
        } catch (Exception e) {
            e.printStackTrace();
            throw new RuntimeException(e);
        }

        this.writeSuccessData(map);
    }

    @Override
    protected void beforeSave(HttpServletRequest request, HttpServletResponse response, CoreBaseInfo model) throws SHRWebException {
        super.beforeSave(request, response, model);
        PerformanceScoringInfo performanceScoringInfo = (PerformanceScoringInfo)model;
        //PerformanceScoringEntryCollection entrys = performanceScoringInfo.getEntrys();
        Context ctx = SHRContext.getInstance().getContext();
        UserInfo user = ContextUtil.getCurrentUserInfo(ctx);
        String userId = user.getId().toString();
        PerfPeriodInfo perforAppraisal = performanceScoringInfo.getPerforAppraisal();
        String periodId = perforAppraisal.getId().toString();
//        PersonInfo personInfo = SHRBillUtil.getCurrPersonInfo();
//        String personId = personInfo.getId().toString();
        performanceScoringInfo.getId();
        if (performanceScoringInfo.getId() == null){
            PerformanceScoringCollection performanceScoringCollection = null;
            try {
                performanceScoringCollection = PerformanceScoringFactory.getLocalInstance(ctx).
                        getPerformanceScoringCollection("where creator = '" + userId + "' and perforAppraisal = '"+periodId+"'");
            } catch (BOSException e) {
                throw new RuntimeException(e);
            }
            if (performanceScoringCollection.size()>0){
                PerformanceScoringInfo info = performanceScoringCollection.get(0);
                String number = info.getNumber();
                throw new ShrWebBizException("ǰڼЧѾݱΪ" + number + "!");
            }
        }

        performanceScoringInfo.setEvaluationDate(new Date());
        HROrgUnitInfo hrOrgUnitInfo = new HROrgUnitInfo();
        hrOrgUnitInfo.setId(BOSUuid.read("00000000-0000-0000-0000-000000000000CCE7AED4"));
        performanceScoringInfo.setHrOrgUnit(hrOrgUnitInfo);
    }


}
