package com.kingdee.eas.custom.performanceScoring.handler;

import com.aliyun.odps.utils.StringUtils;
import com.kingdee.bos.BOSException;
import com.kingdee.bos.Context;
import com.kingdee.bos.dao.IObjectPK;
import com.kingdee.bos.util.BOSUuid;
import com.kingdee.eas.basedata.org.AdminOrgUnitInfo;
import com.kingdee.eas.basedata.org.HROrgUnitInfo;
import com.kingdee.eas.basedata.person.PersonInfo;
import com.kingdee.eas.common.EASBizException;
import com.kingdee.eas.framework.CoreBaseInfo;
import com.kingdee.eas.hr.emp.PersonPositionInfo;
import com.kingdee.eas.hr.perf.*;
import com.kingdee.eas.util.app.DbUtil;
import com.kingdee.jdbc.rowset.IRowSet;
import com.kingdee.shr.ats.web.util.SHRBillUtil;
import com.kingdee.shr.base.syssetting.context.SHRContext;
import com.kingdee.shr.base.syssetting.exception.SHRWebException;
import com.kingdee.shr.base.syssetting.exception.ShrWebBizException;
import com.kingdee.shr.base.syssetting.web.handler.DEPCustomBillEditHandler;
import com.kingdee.shr.perfweb.app.base.evalplan.PerfPeriodInfo;
import org.apache.log4j.Logger;
import org.springframework.ui.ModelMap;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.math.BigDecimal;
import java.math.RoundingMode;
import java.util.*;

/**
 * @Description Чֻ_
 * @Date 2024/12/25 11:00
 * @Created by 30489
 */
public class PerformanceScoringSumDEPEditHandler extends DEPCustomBillEditHandler {

    private static Logger logger = Logger.getLogger("com.kingdee.eas.custom.performanceScoring.handler.PerformanceScoringSumDEPEditHandler");

    public void getPerformanceScoringDataAction(HttpServletRequest request, HttpServletResponse response, ModelMap modelMap) throws SHRWebException {
        Context ctx = SHRContext.getInstance().getContext();
        Map<String, Object> map = new HashMap<String, Object>();
        String billId = request.getParameter("id");//id
        try {
            PerformanceScoringCollection scoringCollection = PerformanceScoringFactory.getLocalInstance(ctx).
                    getPerformanceScoringCollection("where billState = 3 and perforAppraisal = '" + billId + "'");
            if (scoringCollection.size() == 0) {
                throw new ShrWebBizException("ϵͳڼЧֵݣ!");
            }
            getPerformanceSumInfo(billId, ctx);
            List<Map<String, Object>> list = new ArrayList<Map<String, Object>>();
            StringBuilder sql = new StringBuilder();
            sql.append("select").append("\n");
            sql.append("org.fid orgId,").append("\n");
            sql.append("org.Fname_l2 orgName,").append("\n");
            sql.append("person.fid personId,").append("\n");
            sql.append("person.fname_l2 personName,").append("\n");
            sql.append("sum(entry.CFSCORE), avg(entry.CFSCORE) avgNumber").append("\n");
            sql.append("FROM CT_PF_PerformanceScoring per").append("\n");
            sql.append("left join CT_PF_PerformanceScoringEntry entry on per.fid = entry.FPARENTID").append("\n");
            sql.append("left join T_ORG_admin org on org.fid = entry.CFFIRSTDEPID").append("\n");
            sql.append("left join T_BD_person person on person.fid = entry.CFCHARGEDEPPERSONI").append("\n");
            sql.append("where per.CFPERFORAPPRAISALI = '" + billId + "' and per.FBILLSTATE = 3").append("\n");
            sql.append("group by org.fid,org.Fname_l2,person.fid,person.fname_l2").append("\n");
            sql.append("ORDER BY avg(entry.CFSCORE) desc").append("\n");
            IRowSet iRowSet = DbUtil.executeQuery(ctx, sql.toString());
            while (iRowSet.next()) {
                Map<String, Object> orgMap = new HashMap<String, Object>();
                Map<String, Object> personMap = new HashMap<String, Object>();
                Map<String, Object> integrationMap = new HashMap<String, Object>();
                String orgId = iRowSet.getString("orgId");
                String orgName = iRowSet.getString("orgName");
                String personId = iRowSet.getString("personId");
                String personName = iRowSet.getString("personName");
                BigDecimal avgNumber = iRowSet.getBigDecimal("avgNumber").setScale(1, RoundingMode.HALF_UP);
                orgMap.put("id", orgId);
                orgMap.put("name", orgName);
                personMap.put("id", personId);
                personMap.put("name", personName);
                integrationMap.put("firstDep", orgMap);
                integrationMap.put("chargeDepPerson", personMap);
                integrationMap.put("score", avgNumber);
                integrationMap.put("addMultiplyPart", BigDecimal.ZERO);
                list.add(integrationMap);
            }
            PersonInfo personInfo = SHRBillUtil.getCurrPersonInfo();
            String personId = personInfo.getId().toString();
            PersonPositionInfo personPositionInfo = SHRBillUtil.getAdminOrgUnitByPersonId(ctx, personId);
            AdminOrgUnitInfo personDep = personPositionInfo.getPersonDep();
            String depId = personDep.getId().toString();
            String depName = personDep.getName();
            Map<String, String> evaluationMap = new HashMap<String, String>();
            evaluationMap.put("id", depId);
            evaluationMap.put("name", depName);
            map.put("msg", "success");
            map.put("list", list);
            map.put("evaluationMap", evaluationMap);

        } catch (Exception e) {
            e.printStackTrace();
            throw new RuntimeException(e);
        }
        this.writeSuccessData(map);
    }


    //    @Override
//    protected IObjectPK runSave(HttpServletRequest request, HttpServletResponse response, CoreBaseInfo model) throws Exception {
//        PerformanceScoringSumInfo performanceScoringSumInfo = (PerformanceScoringSumInfo)model;
//        Context ctx = SHRContext.getInstance().getContext();
//        String perId = performanceScoringSumInfo.getPerforAppraisal().getId().toString();
//        getPerformanceSumInfo(perId,ctx);
//        performanceScoringSumInfo.setEvaluationDate(new Date());
//        HROrgUnitInfo hrOrgUnitInfo = new HROrgUnitInfo();
//        hrOrgUnitInfo.setId(BOSUuid.read("00000000-0000-0000-0000-000000000000CCE7AED4"));
//        performanceScoringSumInfo.setHrOrgUnit(hrOrgUnitInfo);
//        return super.runSave(request, response, model);
//    }
//
//
    public void getPerformanceSumInfo(String id, Context ctx) throws ShrWebBizException {
        PerformanceScoringSumCollection performanceScoringSumCollection = null;
        try {
            performanceScoringSumCollection = PerformanceScoringSumFactory.getLocalInstance(ctx).getPerformanceScoringSumCollection("select *,perforAppraisal.* where perforAppraisal = '" + id + "'");
        } catch (BOSException e) {
            throw new RuntimeException(e);
        }
        if (performanceScoringSumCollection.size() > 0) {
            PerformanceScoringSumInfo info = performanceScoringSumCollection.get(0);
            PerfPeriodInfo perfPeriodInfo = info.getPerforAppraisal();
            throw new ShrWebBizException("ǰڼЧֻܵѾݱ" + info.getNumber() + "");
        }
    }


    @Override
    protected void beforeSave(HttpServletRequest request, HttpServletResponse response, CoreBaseInfo model) throws SHRWebException {
        super.beforeSave(request, response, model);
        PerformanceScoringSumInfo performanceScoringSumInfo = (PerformanceScoringSumInfo) model;
        Context ctx = SHRContext.getInstance().getContext();
        String perId = performanceScoringSumInfo.getPerforAppraisal().getId().toString();

        PerformanceScoringCollection scoringCollection = null;
        try {
            scoringCollection = PerformanceScoringFactory.getLocalInstance(ctx).
                    getPerformanceScoringCollection("where billState = 3 and perforAppraisal = '" + perId + "'");
        } catch (BOSException e) {
            throw new RuntimeException(e);
        }
        if (scoringCollection.size() == 0) {
            throw new ShrWebBizException("ϵͳڼЧֵݣ!");
        }
        if (performanceScoringSumInfo.getId() == null) {
            getPerformanceSumInfo(perId, ctx);
        }
        performanceScoringSumInfo.setEvaluationDate(new Date());
        HROrgUnitInfo hrOrgUnitInfo = new HROrgUnitInfo();
        hrOrgUnitInfo.setId(BOSUuid.read("00000000-0000-0000-0000-000000000000CCE7AED4"));
        performanceScoringSumInfo.setHrOrgUnit(hrOrgUnitInfo);
    }

}
