package com.kingdee.eas.hr.perf.handler;

import com.kingdee.bos.BOSException;
import com.kingdee.bos.Context;
import com.kingdee.bos.metadata.entity.EntityViewInfo;
import com.kingdee.bos.metadata.entity.FilterInfo;
import com.kingdee.bos.metadata.entity.FilterItemInfo;
import com.kingdee.bos.metadata.entity.SelectorItemCollection;
import com.kingdee.eas.hr.ats.AtsUtil;
import com.kingdee.eas.hr.emp.IPersonPosition;
import com.kingdee.eas.hr.emp.PersonPositionCollection;
import com.kingdee.eas.hr.emp.PersonPositionFactory;
import com.kingdee.eas.hr.emp.PersonPositionInfo;
import com.kingdee.eas.hr.perf.utils.ProjectAllocationUtils;
import com.kingdee.shr.base.syssetting.context.SHRContext;
import com.kingdee.shr.base.syssetting.exception.SHRWebException;
import com.kingdee.shr.base.syssetting.exception.ShrWebBizException;
import com.kingdee.shr.base.syssetting.json.GridDataEntity;
import com.kingdee.shr.base.syssetting.web.handler.ListHandler;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.Set;

/**
 * @author qingwu
 * @date 2025/1/6
 * @apiNote ˾ɱ̯
 */
public class OutsourcingShareListHandler extends ListHandler {
    private Context ctx = SHRContext.getInstance().getContext();

    @Override
    protected void afterGetListData(HttpServletRequest request, HttpServletResponse response, GridDataEntity gridDataEntity) throws SHRWebException {
        List<Map<String, Object>> rows = gridDataEntity.getRows();
        try {
            for (int i = 0; i < rows.size(); i++) {
                Map<String, Object> map = rows.get(i);
                String adminOrgId = map.get("id").toString();
                //ְ
                List<PersonPositionInfo> adminOrgPersonnumList = ProjectAllocationUtils.getZZPersonNum(ctx, adminOrgId);
                map.put("personSum", adminOrgPersonnumList.size());
            }
        } catch (BOSException e) {
            e.printStackTrace();
            throw new ShrWebBizException(e);
        }
    }


}
