package com.kingdee.eas.hr.project.handler;

import com.google.common.collect.Sets;
import com.kingdee.bos.BOSException;
import com.kingdee.bos.Context;
import com.kingdee.bos.dao.ormapping.ObjectUuidPK;
import com.kingdee.bos.metadata.entity.FilterInfo;
import com.kingdee.bos.metadata.entity.FilterItemCollection;
import com.kingdee.bos.metadata.entity.FilterItemInfo;
import com.kingdee.bos.metadata.query.util.CompareType;
import com.kingdee.eas.basedata.person.PersonInfo;
import com.kingdee.eas.common.EASBizException;
import com.kingdee.eas.hr.project.*;
import com.kingdee.shr.base.syssetting.context.SHRContext;
import com.kingdee.shr.base.syssetting.exception.SHRWebException;
import com.kingdee.shr.base.syssetting.exception.ShrWebBizException;
import com.kingdee.shr.base.syssetting.ml.SHRWebResource;
import com.kingdee.shr.base.syssetting.web.dynamic.model.ListUIViewInfo;
import com.kingdee.shr.base.syssetting.web.dynamic.model.TreeNavigationInfo;
import com.kingdee.shr.base.syssetting.web.dynamic.model.UIViewInfo;
import com.kingdee.shr.base.syssetting.web.handler.ListHandler;
import com.kingdee.util.StringUtils;
import org.springframework.ui.ModelMap;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.text.MessageFormat;
import java.util.Arrays;
import java.util.Set;

/**
 * @BelongsProject: dataImpExp820
 * @BelongsPackage: com.kingdee.eas.hr.project.handler
 * @Author: lhbj
 * @CreateTime: 2024-11-27  18:21
 * @Description: TODO
 * @Version: 1.0
 */
public class MemberManagementListHandler extends ProjectTreeListHandler {
    protected String pTypeManagerNumber = "ProjectManager";

    protected String pTypeNumber = "ProjectMember";
    @Override
    public String enableAction(HttpServletRequest request, HttpServletResponse response, ModelMap modelMap) throws SHRWebException {
        String billId = this.getBillId(request);
        String[] ids = billId.split(",");
        Context ctx = SHRContext.getInstance().getContext();

        boolean isHandleEnable=false;
        try {
            IMemberManagement iManagement = MemberManagementFactory.getLocalInstance(ctx);
            IProjectRole iProjectRole = ProjectRoleFactory.getLocalInstance(ctx);
            IProjectType iPType = ProjectTypeFactory.getLocalInstance(ctx);
            for (String str : ids) {
                Set<String> idset = Sets.newHashSet();
                idset.addAll(Arrays.asList(ids));
                idset.remove(str);
                MemberManagementInfo management = iManagement.getMemberManagementInfo(new ObjectUuidPK(str));
                ProjectRoleInfo projectRole = management.getProjectRole();
                PersonInfo personInfo = management.getEmployee();
                ProjectTypeInfo pType = management.getPtype();
                ProjectManagementInfo projectManagement = management.getProjectManagement();
                projectRole =iProjectRole.getProjectRoleInfo(new ObjectUuidPK(projectRole.getId()));
                pType = iPType.getProjectTypeInfo(new ObjectUuidPK(pType.getId()));
                FilterInfo filterInfo = new FilterInfo();
                filterInfo.getFilterItems().add(new FilterItemInfo("projectManagement.id", projectManagement.getId().toString(), CompareType.EQUALS));
                //ΪɫΪĿʱжϽɫ
                if(!(pTypeManagerNumber.equals(pType.getNumber()))) {
                    filterInfo.getFilterItems().add(new FilterItemInfo("projectRole.id", projectRole.getId().toString(), CompareType.EQUALS));
                }
                filterInfo.getFilterItems().add(new FilterItemInfo("state", "1", CompareType.EQUALS));
                filterInfo.getFilterItems().add(new FilterItemInfo("ptype.id", pType.getId().toString(), CompareType.EQUALS));
                filterInfo.getFilterItems().add(new FilterItemInfo("ptype.number", pTypeNumber, CompareType.NOTEQUALS));

                FilterInfo filterInfo4Or = new FilterInfo();
                filterInfo4Or.getFilterItems().add(new FilterItemInfo("id",idset,CompareType.INCLUDE));
                filterInfo4Or.getFilterItems().add(new FilterItemInfo("projectManagement.id", projectManagement.getId().toString(), CompareType.EQUALS));
                //ΪɫΪĿʱжϽɫ
                if(!(pTypeManagerNumber.equals(pType.getNumber()))) {
                    filterInfo4Or.getFilterItems().add(new FilterItemInfo("projectRole.id", projectRole.getId().toString(), CompareType.EQUALS));
                }
                //filterInfo4Or.getFilterItems().add(new FilterItemInfo("state", "1", CompareType.EQUALS));
                filterInfo4Or.getFilterItems().add(new FilterItemInfo("ptype.id", pType.getId().toString(), CompareType.EQUALS));
                filterInfo4Or.getFilterItems().add(new FilterItemInfo("ptype.number", pTypeNumber, CompareType.NOTEQUALS));

                filterInfo.mergeFilter(filterInfo4Or, "or");
                System.out.println(filterInfo.toSql());
                if (iManagement.exists(filterInfo)) {
                    isHandleEnable=false;
                    if((pTypeManagerNumber.equals(pType.getNumber()))) {
                        throw new ShrWebBizException("ѾĿ" + pType.getName() + "ĳԱ,ȽԱúáѡ˶λĿ顣");
                    }else {
                        throw new ShrWebBizException("ѾĿ" + pType.getName() + ",Ŀɫ" + projectRole.getName() + "ĳԱ,ȽԱúá");
                    }

                }else{
                    isHandleEnable=true;
                }
            }
        } catch (BOSException e) {
            throw new RuntimeException(e);
        } catch (EASBizException e) {
            throw new RuntimeException(e);
        }
        if(isHandleEnable){
            super.handleEnable(request, "enable");
        }
        return null;
    }
    protected String getBillId(HttpServletRequest request) throws SHRWebException {
        String billId = (String)request.getAttribute("billId");
        if (StringUtils.isEmpty(billId)) {
            billId = request.getParameter("billId");
        }

        if (StringUtils.isEmpty(billId)) {
            billId = request.getParameter("billID");
        }

        if (StringUtils.isEmpty(billId)) {
            throw new ShrWebBizException(MessageFormat.format(SHRWebResource.getString("com.kingdee.shr.base.syssetting.SHRSyssettingResource", "is_empty"), "billId"));
        } else {
            return billId;
        }
    }

//    @Override
//    protected FilterInfo getDefaultFilter(HttpServletRequest request, HttpServletResponse response) throws SHRWebException {
//        String userAdminOrgRangeSql = this.assembleTreeDataUserAdminOrgRangeSQL(request);
//        FilterInfo ifo = new FilterInfo();
//        ifo.getFilterItems().add(new FilterItemInfo("projectManagement.adminOrg.id in("+userAdminOrgRangeSql+")"));
//        ifo.getFilterItems().add(new FilterItemInfo("projectManagement.projectState in('1','2')"));
//        return ifo;
//    }
}
