package com.kingdee.eas.hr.project.handler;

import com.kingdee.bos.BOSException;
import com.kingdee.bos.Context;
import com.kingdee.bos.dao.ormapping.ObjectUuidPK;
import com.kingdee.bos.metadata.entity.EntityViewInfo;
import com.kingdee.bos.metadata.entity.FilterInfo;
import com.kingdee.bos.metadata.entity.FilterItemCollection;
import com.kingdee.bos.metadata.entity.FilterItemInfo;
import com.kingdee.bos.metadata.entity.SelectorItemCollection;
import com.kingdee.bos.metadata.entity.SelectorItemInfo;
import com.kingdee.bos.metadata.query.util.CompareType;
import com.kingdee.eas.common.EASBizException;
import com.kingdee.eas.hr.base.IHRBillBase;
import com.kingdee.eas.hr.project.IProjectChange;
import com.kingdee.eas.hr.project.IProjectManagement;
import com.kingdee.eas.hr.project.ProjectChangeCollection;
import com.kingdee.eas.hr.project.ProjectChangeFactory;
import com.kingdee.eas.hr.project.ProjectChangeInfo;
import com.kingdee.eas.hr.project.ProjectManagementFactory;
import com.kingdee.eas.hr.project.ProjectManagementInfo;
import com.kingdee.shr.base.syssetting.context.SHRContext;
import com.kingdee.shr.base.syssetting.exception.SHRWebException;
import com.kingdee.shr.base.syssetting.exception.ShrWebBizException;
import com.kingdee.shr.base.syssetting.web.handler.ListHandler;
import com.kingdee.util.StringUtils;
import java.io.PrintStream;
import java.math.BigDecimal;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import org.apache.log4j.Logger;
import org.springframework.ui.ModelMap;

public class ProjectChangeListHandler extends ListHandler
{
  private static Logger logger = Logger.getLogger(ProjectChangeListHandler.class);
  
  public void abortBillAction(HttpServletRequest request, HttpServletResponse response, ModelMap modelMap)
			throws SHRWebException {
		String billId = this.getBillId(request);
		if (!StringUtils.isEmpty(billId)) {
			IHRBillBase iHRBillBase = (IHRBillBase) this.getBizInterface(request);
			try {
				iHRBillBase.getHRBillBaseInfo(new ObjectUuidPK(billId));
				iHRBillBase.abortBizBill(billId);
				com.kingdee.shr.base.syssetting.web.json.JSONUtils.SUCCESS(billId);
			} catch (EASBizException var11) {
				throw new ShrWebBizException("ʧܣϵԱ"+var11.getMessage());
			} catch (BOSException var12) {
				throw new SHRWebException(var12.getMessage(), var12);
			}
		}
	}

	public void untiCheckAction(HttpServletRequest request, HttpServletResponse response, ModelMap modelMap)
			throws SHRWebException {
		String billId = this.getBillId(request);
		if (!StringUtils.isEmpty(billId)) {
			IHRBillBase iHRBillBase = (IHRBillBase) this.getBizInterface(request);

			try {
				iHRBillBase.untiCheckBizBill(billId);
				com.kingdee.shr.base.syssetting.web.json.JSONUtils.SUCCESS(billId);
			} catch (EASBizException var7) {
				logger.error(var7.getMessage(), var7);
				throw new ShrWebBizException(var7.getMessage(), var7);
			} catch (BOSException var8) {
				logger.error(var8.getMessage(), var8);
				throw new SHRWebException(var8);
			}
		}

	}
}