package com.kingdee.eas.hr.project.osf;

import com.google.common.collect.Maps;
import com.kingdee.bos.BOSException;
import com.kingdee.bos.Context;
import com.kingdee.bos.bsf.service.app.IHRMsfService;
import com.kingdee.eas.base.codingrule.CodingRuleManagerFactory;
import com.kingdee.eas.base.codingrule.ICodingRuleManager;

import com.kingdee.eas.common.EASBizException;

import com.kingdee.eas.hr.project.WorkHoursReportInfo;
import org.apache.commons.lang.StringUtils;

import java.util.Map;

/**
 * @BelongsProject: dataImpExp820
 * @BelongsPackage: com.kingdee.eas.hr.project.osf
 * @Author: lhbj'
 * @CreateTime: 2025-01-02  16:40
 * @Description: TODO
 * @Version: 1.0
 */
public class CodingRuleService implements IHRMsfService {
    @Override
    public Object process(Context context, Map<String, Object> map) throws EASBizException, BOSException {

        String orgUnitID = (String) map.get("orgUnitID");
        if(StringUtils.isBlank(orgUnitID)){
            orgUnitID="00000000-0000-0000-0000-000000000000CCE7AED4";
        }
        Map<String, String> stringMap = Maps.newHashMap();
        try {
            ICodingRuleManager iCodingRuleManager = CodingRuleManagerFactory.getLocalInstance(context);
            WorkHoursReportInfo workHoursReportInfo = new WorkHoursReportInfo();
            String number = iCodingRuleManager.getNumber(workHoursReportInfo, orgUnitID);
            stringMap.put("number", number);
            stringMap.put("code", "200");
        }catch (Exception e){
            e.printStackTrace();
            stringMap.put("number", "");
            stringMap.put("code", "500");
        }
        return stringMap;
    }
}
